import globalPluginHandler
import controlTypes as types
from speech import cancelSpeech
import api
import textInfos
import speech
import globalVars
from ui import message
import addonHandler
addonHandler.initTranslation()
import scriptHandler,wx,gui
class GlobalPlugin(globalPluginHandler.GlobalPlugin):
	start=None
	end=None

	def terminate(self):
		try:
			gui.initialize()
		except wx.PyDeadObjectError:
			pass
	def goto(self):
		d = wx.TextEntryDialog(gui.mainFrame, _("Enter a percentage to jump to"), _("Jump to percent"))
		def callback(result):
			if result == wx.ID_OK:

				wx.CallLater(100,self.jumping, d.GetValue())
		gui.runScriptModalDialog(d, callback)
	def jumping(self,num):
		obj=api.getFocusObject()
		treeInterceptor=obj.treeInterceptor
		if hasattr(treeInterceptor,'TextInfo') and not treeInterceptor.passThrough:
			obj=treeInterceptor
		try:
			self.start =obj.makeTextInfo(textInfos.POSITION_ALL)
		except (NotImplementedError, RuntimeError):
			return
		totalCharsLen=float(len(self.start.text)-1)
		result=float(num)*totalCharsLen/100
		try:
			self.start.move(textInfos.UNIT_CHARACTER,int(result),"start")
			self.start.updateCaret()
			self.start.expand(textInfos.UNIT_LINE)
			cancelSpeech()
		except NotImplementedError:
			wx.CallAfter(gui.messageBox, _("This doesn't look like a proper text"), _("Error"), wx.OK|wx.ICON_ERROR)
			pass
		message(self.start.text)
	def script_debug(self, gesture):
		if scriptHandler.getLastScriptRepeatCount()==1:
			self.goto()
			return
		obj=api.getFocusObject()
		if obj.role==types.ROLE_LISTITEM:
#get rid of desktop and explorer list headers
			if obj.parent.children[-1].name=="Header Control": obj.parent.children.pop(-1)
			index=float(obj.parent.children.index(obj)+1)
			total=float(len(obj.parent.children))

			result =index/total*100
			message(_("{0} percent, item {1} of {2}").format(int(result),int(index),int(total)))
			return
		treeInterceptor=obj.treeInterceptor
		if hasattr(treeInterceptor,'TextInfo') and not treeInterceptor.passThrough:
			obj=treeInterceptor
		try:
			self.start =obj.makeTextInfo(textInfos.POSITION_ALL)
			words=self.start.text.split()
			words=len(words)
		except (NotImplementedError, RuntimeError):
			return
		totalCharsLen = float(len(self.start.text))
		try:
			self.end =obj.makeTextInfo(textInfos.POSITION_CARET)
		except (NotImplementedError, RuntimeError):
			message(_("Caret not found"))
			return
		self.start.setEndPoint(self.end, "endToStart")
		posCharsLen = float(len(self.start.text))
		result = posCharsLen/totalCharsLen*100
		message(_("{0} percent {1} words").format(int(result),words))
		#self.jumpToLine(1)
	def jumpToLine(self,num):
		obj=api.getFocusObject()
		treeInterceptor=obj.treeInterceptor
		if hasattr(treeInterceptor,'TextInfo') and not treeInterceptor.passThrough:
			obj=treeInterceptor
		try:
			self.start =obj.makeTextInfo(textInfos.POSITION_ALL)
			words=self.start.text.split()
			words=len(words)
		except (NotImplementedError, RuntimeError):
			return
		totalCharsLen = float(len(self.start.text))
		self.start.move(textInfos.UNIT_LINE,num-1,"start")
		self.start.updateCaret()
		#self.start.unitIndex(textInfos.UNIT_LINE)

		self.start.expand(textInfos.UNIT_LINE)
		cancelSpeech()
		message(self.start.text)

	__gestures = {
		"kb:NVDA+control+p": "debug"
	}
